"use strict";
var universal = require('angular2-universal-preview');
var through = require('through2');
var gutil = require('gutil');
var PluginError = gutil.PluginError;
function prerender(options) {
    function transform(file, enc, cb) {
        if (file.isStream()) {
            return cb(new PluginError('angular2-gulp-prerender', 'Streaming is not supported'));
        }
        var template = file.contents.toString();
        // bootstrap and render component to string
        var bootloader = options.bootloader;
        if (!options.bootloader) {
            var doc = universal.parseDocument(template);
            options.document = doc;
            options.template = options.template || template;
            options.bootloader = options;
        }
        bootloader = universal.Bootloader.create(options.bootloader);
        return bootloader.serializeApplication()
            .then(function (html) {
            file.contents = new Buffer(html);
            cb(null, file);
        });
    }
    return through.obj(transform);
}
exports.prerender = prerender;
function GulpAngular2Render(options) {
    console.warn('DEPRECATION WARNING: `GulpAngular2Render` is no longer supported and will be removed in next release. use `prerender`');
    return prerender(options);
}
exports.GulpAngular2Render = GulpAngular2Render;
function Prerender(options) {
    console.warn('DEPRECATION WARNING: `Prerender` is no longer supported and will be removed in next release. use `prerender`');
    return prerender(options);
}
exports.Prerender = Prerender;
//# sourceMappingURL=prerender.js.map